.MODEL SMALL
.286
RomBiosData     SEGMENT AT 40H
	ORG 1AH
	Head            DW      ?
	Tail            DW      ?
	KeyboardBuffer  DW      16 DUP (?)
	BufferEnd       LABEL WORD
RomBiosData ENDS


.CODE

ORG 100H
Keyboard EQU 9 		                ; Print-Sc pressed interrupt
Timer    EQU 8				; System Timer interrupt called 18.2 times a sec.

Start:  jmp LoadProg
	OldKeyInt       LABEL WORD      ; i.e. oldkeyint is a pointer to a word
	OldKeyboardInt        DD ?      ; that ? means anysing! (Remember unions)

	OldTimerIntW	LABEL WORD
	OldTimerIntD	DD ?

	TimerExecute    db 0		; Execute Timer Interrupt Handler?
	TimerCounter	db 0		; How Many times was the T.I.H. executed
	Ticks		db 0

	Sector          db 1		; Intial Sector no.
	Track           db 1		; Initial Track no.
	Side            db 0		; Initial Side 

	HorizLineno     dw 0
	Buffer          db 768 dup (?)  ; buffer 4 320 pixels & 256*3 RGBs

PUBLIC GetPalette			; Gets the current palette
GetPalette PROC				; and Put it at DS:SI
	mov si,0
	mov cx,255			; 256 palette entries
GetPaletteLoop:
	mov dx,03c7h			; Set the no. color to be got
	mov al,cl
	out dx,al
	mov dx,03c9h			; get the red component
	in al,dx			; in al
	mov buffer[si],al			; store it and increase the index SI
	inc si
	in al,dx			; do the same with the green
	mov buffer[si],al
	inc si
	in al,dx			; and the same with the blue :)
	mov buffer[si],al
	inc si
	loop GetPaletteLoop
	ret
ENDP GetPalette


PUBLIC WriteBufferInFile
WriteBufferInFile PROC
	pusha				; keep all registers in the stack
	mov ax,cs			; Segment of the buffer 4 saving
	mov es,ax			; CS ;-) in ES (a COM file!)
	mov ah,03h			; function no. 3
	mov al,1			; 1 sector 2 b written
	mov ch,[Track]			; track no.
	mov cl,[Sector]			; sector no.
	mov dh,[Side]			; side no.
	mov dl,0			; Drive 0 (A:)
	int 13h
	cmp al,1			; Check the no. of sectors read
	jz okok				; if 1 then goto okok:)
	mov ah,0			; else wait 4 a key
	int 16h
	mov ax,3			; change 2 text mode
	int 10h
	mov ax,4c00h                    ; bail outta everything!
	int 21h
okok:
	inc [Sector]			; next sector
	cmp [Sector],18			; if sector 18 reached
	jne ExitWrite			
	mov [Sector],1			; reset the sectors to 1
	inc [Track]			; increment the tracks no
	cmp [Track],80			; if track 80 reached
	jne ExitWrite
	mov [Track],1			; reset the track to 1
	inc [Side]			; change to the second side
ExitWrite:
	popa				; restore all regs out of the stack
	ret
WriteBufferInFile ENDP


PUBLIC CaptureScreen
CaptureScreen PROC
	call GetPalette			; Get the 256*3 RGBs in Buffer


	mov bx,offset buffer		; Save the 1st 512 elements 
	call WriteBufferInFile		; as a sector
	mov bx,offset buffer		; Save starting from offset 512
	add bx,512			; in another sector
	call WriteBufferInFile		; What a waste?!! 
	mov ax,0a000h                   ; Weird segment'stuff :-)))))))
	sub ax,20
	push ax

HorizontalLine:
	mov di,0
	pop ax
	add ax,20
	push ax
HorizontalPlot:
	mov es,ax
	mov dl,byte ptr es:[di]
	mov buffer[di],dl
	inc di
	cmp di,320
	jnz HorizontalPlot
	

	mov bx,offset buffer		; Write the 320 pixels in the current
	call WriteBufferInFile		; line to a sector. Wasting space, huh?!
	
	inc [HorizLineno]
	cmp [HorizLineno],200
	jnz HorizontalLine              ; Read 200 Lines of the 320x200
	pop ax
	ret

CaptureScreen ENDP


KBProc PROC
	push ax                         ;push all registers into the stack
	push bx
	push cx
	push dx
	push di
	push si
	push ds
	push es
	pushf
	call OldKeyboardInt		; Call the old interrupt of the keyboard
					; Shoghl 3ala maya beda :)))))))))))


	assume ds:RomBiosData	
	mov bx,RomBiosData		; make ds pointing to the 
	mov ds,bx			; RomBiosData at 40h
	mov bx,Tail			; point bx 2 the tail of the KB buffer
	cmp bx,Head			; Check if head=tail , i.e. buffer empty
	je Exit				; exit
	sub bx,2			; decrease bx by 2 
	cmp bx,offset KeyboardBuffer	; Check if the offset of the kb buffer
	jae NoWrap			; isn't exceeded downwards
	mov bx,offset BufferEnd		; if so, get 2 elements lower
	sub bx,2			; lower than the bufferend

NoWrap:
	mov dx,[bx]			
	cmp dx,1F00h			; Check if the key is ALT-S
	jne Exit			; If it isn't exit
	mov Tail,bx


	mov [Ticks],2			; Just Make the Timer interrupt handler
	mov [TimerCounter],0
	mov [TimerExecute],1		; takes on with the job after 1/18.2 of
					; the second
Exit:
	pop es				; Get the registers back out of the
	pop ds				; honourable stack :)
	pop si
	pop di
	pop dx
	pop cx
	pop bx
	pop ax
	iret				; Return with a marvellous interrupt return :)
KBProc ENDP


TimerProc PROC
	push ax                         ;push all registers into the stack
	push bx
	push cx
	push dx
	push di
	push si
	push ds
	push es
	pushf
	call OldTimerIntD		; Call the old timer interrupt
 
	cmp [TimerExecute],0
	jz ExitTimerHandler
	
	inc [TimerCounter]
	mov ah,[Ticks]
	cmp ah,[TimerCounter]
	jnz ExitTimerHandler		; approx (Ticks/18.2) Second passed?

					; (Ticks/18.2) secs, passed! oh yes!
	mov [TimerExecute],0		; Don't execute the timer the next time!
	mov [TimerCounter],0		; Reset the timer counter
	mov [Ticks],0

BeginChoices:
	mov ah,0			; Read Character from keyboard
	int 16h

	cmp al,'s'
	jnz DontSave

	mov [HorizLineNo],0		; Reset the HorizlineNo counter
	call CaptureScreen
	jmp BeginChoices
DontSave:
	cmp al,'q'
	jnz DontQuit
	jmp ExitTimerHandler	
DontQuit:
	cmp al,'t'
	jnz ExitTimerHandler
	mov [Ticks],1			; Come Back to that I.H. after 3 ticks
	mov [TimerCounter],0		; Reset the timer counter
	mov [TimerExecute],1		; Start Executing the I.H. from now! Tada!

ExitTimerHandler:	
	pop es				; Get the registers back out of the
	pop ds				; honourable stack :)
	pop si
	pop di
	pop dx
	pop cx
	pop bx
	pop ax
	iret				; Return with a marvellous interrupt return :)
TimerProc ENDP


EndOfTSR:				; The code 2b TSRed ends here
Message     db  "Capture-IT! (C) 1996 Ahmed Mohamed Reda ",13,10
            db  "Press Alt-S to activate .",13,10
            db  "When active press  S to capture the screen",13,10
	    db  "		   T to execute the program for 1/6 sec and regain control",13,10
	    db  "		   Any other key to de-activate$"

; In the following program , note that CS=DS as it is a COM program

LoadProg PROC
	mov dx,offset Message   	; Get the offset of the message
	mov ah,9     			; DS & ES already =CS
	int 21h      			; Print the message

	mov ah,35h                      ;Get the KB interrupt entry
	mov al,Keyboard		        ;from the interrupt vector
	int 21h
	mov OldKeyInt,bx                ;save the lowest significant word in
	mov OldKeyInt[2],es             ;label address of the label oldkeyint

	mov ah,25h                      ;Save the KBProc address in the
	lea dx,KBProc                   ;interrupt vector instead of that
	int 21h                         ;of the keyboard input

	mov ah,35h			; Intercept the timer interrupt too:)
	mov al,Timer
	int 21h
	mov OldTimerIntW,bx
	mov OldTimerIntW[2],es

	mov ah,25h
	lea dx,TimerProc
	int 21h

	mov dx,offset EndOfTSR          ;set the offset of loadprog 2b the
	int 27h                         ;last portion of the prog 2b kept in
LoadProg ENDP                           ;memory and exit a TSR exit!
	END Start       
