; OpenFile:	This procedure opens a file 
; 
; Inputs: 
;		File name pointed to by DS:DX
;		AL	Access mode
; Outputs:
;		CF 	clear if successful
;		AX 	File Handle	if successful
;			Error Code	if not
; Registers Used/Destroyed:
;		AX,DS,DX
PUBLIC OpenFile
OpenFile PROC
	mov ah,3dh
	int 21h
	ret
OpenFile ENDP

; ReadFile:	This procedure reads from a file
; Inputs:
;		BX	File Handle
;		CX	Number of bytes to be read
;		DS:DX	Pointer to buffer area for the read bytes to be put
; Outputs:
;		CF	Clear on success
;		AX	No. of bytes read if successful
;		AX	Error code if not successful
; Registers Used/Destroyed:
;		AX,BX,CX,DX,DS
PUBLIC ReadFile
ReadFile PROC
	mov ah,3fh			;read from file fn. .
	int 21h
	ret
ReadFile ENDP
	

;CloseFile:	This procedure closes a file
;Inputs:
;		BX 	File Handle
; Outputs:
;		CF	Clear on success
;		AX	error code if not successful
; Registers Used/Destroyed:
;		AX,BX
PUBLIC CloseFile
CloseFile PROC
	mov ah,3eh
	int 21h
	ret
CloseFile ENDP


; WriteFile:	This procedure writes to a file
; Inputs:
;		BX	File Handle
;		CX	Number of bytes to be read
;		DS:DX	Pointer to buffer area for the bytes to be written
; Outputs:
;		CF	Clear on success
;		AX 	No. of bytes written if successful
;			Error code if not successful
; Registers Used/Destroyed:
;		AX,BX,CX,DX,DS
PUBLIC WriteFile
WriteFile PROC
	mov ah,40h
	int 21h
	ret
WriteFile ENDP


; CreateTruncateFile:	This procedure creates a file if it doesn't
;			exist or sets it to zero length if it
;			do exist
; Inputs:	
;		CX	File Attributes
;		DS:DX	Pointer to Filename
; Outputs:
;		CF	Clear on success
;		AX	File handle if successful
;			Error code if not successful
; Registers Used/Destroyed:
;		AX,CX,DX,DS

PUBLIC CreateTruncateFile
CreateTruncateFile	PROC
	mov ah,3ch
	int 21h
	ret
CreateTruncateFile	ENDP
