.Model Small
.286
.Data
.Stack
.Code

	Sector          db 1
	Track           db 1
	Side            db 0

        HorizLineno     dw 0
	Buffer          db 2512 dup (?)

PUBLIC SetScreenMode
SetScreenMode PROC
	mov ax,13h			;Set the Screen to mode 13h
	int 010h			;i.e. 320x200x256
	ret
SetScreenMode ENDP




SetPalette PROC
        mov si,offset buffer
        mov ax,seg buffer
        mov ds,ax

        mov cx,255
palloop:

        mov dx,3C8H                     ;Set the color no. 2b changed
	mov al,cl
	out dx,al
	mov dx,3c9H			;Set the color attributes
        lodsb
	out dx,al			;Set the Red attributes of the col.
        lodsb
	out DX,AL
        lodsb
	out DX,AL
        loop palloop
	ret
SetPalette ENDP





PUBLIC ReadSectorInBuffer
ReadSectorInBuffer PROC
	pusha
	mov ax,seg buffer
	mov es,ax
	mov ah,02h
	mov al,1
	mov ch,[Track]
	mov cl,[Sector]
	mov dh,[Side]
	mov dl,0
	int 13h
	cmp al,1
	jz okok
	mov ah,0
	int 16h
	mov ax,3
	int 10h
	mov ax,4c00h                    ;Exit this program :-((
	int 21h
okok:

	inc [Sector]
	cmp [Sector],18
	jne ExitWrite
	mov [Sector],1
	inc [Track]
	cmp [Track],80
	jne ExitWrite
	mov [Track],1
	inc [Side]
ExitWrite:
	popa
	ret
ReadSectorInBuffer ENDP


PUBLIC LoadScreen
LoadScreen PROC
        mov bx,offset buffer            ; Save the 1st 512 elements
        call ReadSectorInBuffer


	mov bx,offset buffer		; Save starting from offset 512
	add bx,512			; in another sector
        call ReadSectorInBuffer

        call SetPalette                 ; Get the 256*3 RGBs in Buffer

	mov ax,0a000h                   ;Weird segment'stuff :-)))))))
	sub ax,20
	push ax

HorizontalLine:
	mov di,0
	pop ax
	add ax,20
	push ax
        mov bx,offset buffer            ; Save the 1st 512 elements
        call ReadSectorInBuffer
HorizontalPlot:
	mov es,ax
	mov dl,buffer[di]
	mov byte ptr es:[di],dl

	inc di
	cmp di,320
	jnz HorizontalPlot
	
	
	inc [HorizLineno]
	cmp [HorizLineno],200           
	jnz HorizontalLine              ;Read 200 Lines of the 320x200
	pop ax
	ret

LoadScreen ENDP

Start:
	call SetScreenMode
	call LoadScreen
        mov HorizLineno,0

        mov ah,0
        int 16h
        cmp al,27
        jnz Start
	mov ax,4c00h			;Exit this program :-((
	int 21h

End Start
